/**
 * Titel:     Quelltext zu Kapitel 11 <br />
 * Buch:      Grundkurs-Java fr Wirtschaftsinformatiker. Vieweg 2007. <br />
 * Autoren:   Klaus-Georg Deck und Herbert Neuendorf
 * Copyright: Copyright (c) 2007 <br />
 * 
 * @author Herbert Neuendorf<br />
 * @version 1.0 <br />
 * 
 */
class Bruch {
	private int zaehler;    private int nenner;
	public Bruch( int zaehler, int nenner ) {
		if( nenner == 0 ) { 
			IO.writeln( "Unzulssiger Nenner!" );    nenner = 1;
		}
		this.zaehler = zaehler;     this.nenner = nenner;
     	this.kuerze();
	}
	public String toString() { 
		return (zaehler + "/" + nenner); 
	}
	public Bruch kehrWert() {
		return new Bruch( nenner, zaehler );
	}
	public Bruch negiere() { 
		return new Bruch( -zaehler, nenner );
	}
	public Bruch add( Bruch b ) {
		int nZ = this.zaehler * b.nenner + this.nenner * b.zaehler;
		int nN = this.nenner * b.nenner;
		Bruch badd = new Bruch( nZ, nN );
		return badd;
	}
	public Bruch mult( Bruch b ) {
		int nZ = this.zaehler * b.zaehler;
		int nN = this.nenner * b.nenner;
		Bruch bmult = new Bruch( nZ, nN );
		return bmult;
	}
	Bruch potenz( int p ) {
		Bruch b = new Bruch( zaehler, nenner );
		int n = p;
		if( p == 0 ) { 
			b.zaehler = 1; 
			b.nenner = 1; 
			return b;
		}
		if( p < 0 ) n = -p;            // negativer Exponent
		for( int i = 1; i < n; i++ ) {  
			b = b.mult( this );  
		}
		if( p < 0 ) b = b.kehrWert();  // negativer Exponent
		return b;
	}
	public boolean istGleich( Bruch b ) {
		return  this.zaehler==b.zaehler && this.nenner==b.nenner;
	}
	private void kuerze() {
		int a = ggT( zaehler, nenner );
		zaehler = zaehler/a ;
		nenner = nenner/a ;
		if( nenner < 0 ) {    // Minuszeichen krzen oder zum Zhler
         	zaehler = - zaehler;    nenner = - nenner;
		}   
	}
	private static int ggT( int a, int b ) { // Euklid-Algorithmus
		if( b < 0 ) b = -b;  
		int r = a % b;
		while( r != 0 ) { 
			a = b;    b = r;    r = a % b; 
		}
		return b;
	}
}

public class Bruchrechner {
	public static void main( String[] args ) {
		Bruch b1 = new Bruch( 2,3 );    
		Bruch b2 = new Bruch( 4,5 );
		Bruch b3;
		
		// Entgegennahme der zurckgelieferten Bruch-Referenzen:
		b3 = b1.add(b2);         IO.writeln( "Bruch: " + b3 );
		b3 = b1.mult(b2);        IO.writeln( "Bruch: " + b3 );
		b3 = b1.potenz( 3 );     IO.writeln( "Bruch: " + b3 );
		
		// Direkte Verwendung der zurckgelieferten Referenzen:
		IO.writeln( "Bruch: " + b1.add( b2 ) );	
		IO.writeln( "Bruch: " + b1.mult( b2 ) );
		IO.writeln( "Bruch: " + b1.potenz( 3 ) );
		IO.writeln( "Br: " + b2.add( b2 ).potenz( 4 ).mult( b1 ) );
	}
}

   


 






















